#ifndef __UTIL_H__
#define __UTIL_H__

#include "oxfloat.h"

class Util {
public:
	// _r[s쐬
	static Float4x4 lookAtLH(const Float3 &target = Float3(0.0f, 0.0f, 0.0f), const Float3 &eye = Float3(0.0f, 0.0f, -50.0f), const Float3 &up = Float3(0.0f, 1.0f, 0.0f)) {
		Float4x4 out;
		Float3 &zaxis = (target - eye).normalizeND();
		Float3 &xaxis = up.cross(zaxis).normalizeND();
		Float3 &yaxis = zaxis.cross(xaxis);
		out.m11 = xaxis.x; out.m12 = yaxis.x; out.m13 = zaxis.x; out.m14 = 0.0f;
		out.m21 = xaxis.y; out.m22 = yaxis.y; out.m23 = zaxis.y; out.m24 = 0.0f;
		out.m31 = xaxis.z; out.m32 = yaxis.z; out.m33 = zaxis.z; out.m34 = 0.0f;
		out.m41 = -xaxis.dot(eye); out.m42 = -yaxis.dot(eye); out.m43 = -zaxis.dot(eye); out.m44 = 1.0f;
		return out;
	}

	// ˉeϊs擾
	static Float4x4 perspLH(float fovY = toRad(30.0f), float screenX = 640.0f, float screenY = 480.0f, float nZ = 1.0f, float fZ = 3000.0f) {
		Float4x4 out(Float4x4::getZero());
		float yScale = cotf( ((fovY == 0.0f) ? 30.0f : fovY) / 2.0f );
		float xScale = (screenY == 0.0f ? 480.0f : screenY) * yScale / ((screenX == 0.0f) ? 640.0f : screenX);
		float subZ = (fZ - nZ == 0.0f) ? 3000.0f : fZ - nZ;
		float farZ = (fZ == 0.0f) ? 3001.0f : fZ;
		float nearZ = (nZ == 0.0f) ? 1.0f : nZ;
		out.m11 = xScale;
		out.m22 = yScale;
		out.m33 = farZ / subZ;
		out.m34 = 1.0f;
		out.m43 = -nearZ * farZ / subZ;

		return out;
	}

	static float _pi() {
		return 3.14159265358979f;
	}

	static float _2pi() {
		return _pi() * 2.0f;
	}

	// fO[WA
	static float toRad(float deg) {
		return deg * _2pi() / 360.0f;
	}

	// cot
	static float cotf(float v) {
		return 1.0f / tanf(v);
	}
};

#endif
